/************************************************************

Created: Tuesday, November 6, 1991
    AFPCall.h
    C++ Interface to the AppleTalk Filing Protocol
	M.Vierling


        Copyright Apple Computer, Inc. 1985-1991
        All rights reserved

************************************************************/
#ifndef		AFPCall_H
#define		AFPCall_H

#include <Types.h>
#include <AppleTalk.h>

class TAFPCall
{
public:
	short GetSession() const{ return fSessRefnum; }
	void SetTimeout( char Timeout ) { fAspTimeout = Timeout; }
	char GetTimeout() const{ return fAspTimeout; }
	void SetRetry( char Retry ) { fAspRetry = Retry; }
	char GetRetry() const{ return fAspRetry; }
protected:
	OSErr fErrResult;
	
	TAFPCall();
	~TAFPCall();
	OSErr IAFPCall();
	OSErr DoCommand( Ptr cbPtr, unsigned short cbSize,
					 Ptr rbPtr, unsigned short rbSize );
	virtual OSErr DoAFPCommand( XPPParmBlkPtr theParamPtr );
	OSErr DoGetStatus( Ptr rbPtr, unsigned short rbSize, AddrBlock addrBlock );
	OSErr DoLogin( Ptr cbPtr, unsigned short cbSize,
				   Ptr rbPtr, unsigned short rbSize, AddrBlock addrBlock );
	OSErr DoWrite( Ptr cbPtr, unsigned short cbSize,
				   Ptr rbPtr, unsigned short rbSize,
				   Ptr wdPtr, unsigned short wdSize );
	OSErr DoLogout();
	OSErr SetError();
	virtual void Debug( OSErr theErr, const char * message );
private:
	char 			fAspTimeout;
	char			fAspRetry;
	short			fXPPRefNum;
	short			fSessRefnum;
	short			fMaxCommandSize;
	short			fMaxQuantumSize;
	Ptr				fafpAttnRoutine;
	Ptr				fafpSCBPtr;
	ProcPtr			fioCompletion;
	XPPParmBlkPtr	fParamPtr;
	void 			IParamBlock();
};

#endif
