#
#	Apple Macintosh Developer Technical Support
#
#	MultiFinder-Aware Simple TextEdit Sample Application
#
#	ATQWatcher
#
#	[P]ATQWatcher.make	-	Make Source
#
#	Copyright  Apple Computer, Inc. 1989-1990
#	All rights reserved.
#
#	Versions:	
#				1.00				08/88
#				1.01				11/88
#				1.02				04/89	MPW 3.1
#				1.03				02/90	MPW 3.2
#				1.04				1/93
#
#	Change History:
#				1/7/93	RRK	Changed calls to LAPAddATQ and LAPRmvATQ to used
#							the fixed routines in the file ATQFix.c instead
#
#	Components:
#				ATQWatcher.p			Feb.  1, 1990
#				ATQWatcherGlue.a		Feb.  1, 1990
#				ATQWatcher.r			Feb.  1, 1990
#				ATQWatcher.h			Feb.  1, 1990
#				ATQCGlue.c				Feb.  1, 1990
#				ATQFix.c				Jan.  7, 1993
#				makefile				Feb.  1, 1990
#
#	ATQWatcher is an example application that demonstrates how 
#	to initialize the commonly used toolbox managers, operate 
#	successfully under MultiFinder, handle desk accessories and 
#	create, grow, and zoom windows. The fundamental TextEdit 
#	toolbox calls and TextEdit autoscroll are demonstrated. It 
#	also shows how to create and maintain scrollbar controls.
#
#	It does not by any means demonstrate all the techniques you 
#	need for a large application. In particular, Sample does not 
#	cover exception handling, multiple windows/documents, 
#	sophisticated memory management, printing, or undo. All of 
#	these are vital parts of a normal full-sized application.
#
#	This application is an example of the form of a Macintosh 
#	application; it is NOT a template. It is NOT intended to be 
#	used as a foundation for the next world-class, best-selling, 
#	600K application. A stick figure drawing of the human body may 
#	be a good example of the form for a painting, but that does not 
#	mean it should be used as the basis for the next Mona Lisa.
#
#	We recommend that you review this program or Sample before 
#	beginning a new application. Sample is a simple app. which doesnt 
#	use TextEdit or the Control Manager.
#
# 	You can define {SymOptions} as "-sym on" or "-sym off" for use with SADE
POptions = {SymOptions}

PObjs	=	ATQWatcher.p.o 
			ATQWatcherGlue.a.o 
			ATQCGlue.c.o 
			TransQueue.p.o 
			"{Libraries}"Runtime.o 
			"{Libraries}"Interface.o 
			"{PLibraries}"PasLib.o

ATQWatcher		 {PObjs} makefile
			Link -o {Targ} {PObjs} {SymOptions}
			SetFile {Targ} -t APPL -c 'MOOT' -a B

ATQWatcher		 ATQWatcher.r ATQWatcher.h makefile
			Rez -rd -append -o {Targ} ATQWatcher.r

ATQWatcher.p.o	 ATQWatcher.p makefile

ATQWatcherGlue.a.o  ATQWatcherGlue.a makefile

TransQueue.p.o  TransQueue.p makefile

ATQCGlue.c.o  ATQCGlue.c makefile
